---
# tasks file for common
- name: configure ufw
  block:
    - name: install ufw package
      apt:
        name: ufw
        update_cache: yes
    
    - name: allow ssh port on ufw
      ufw:
        rule: allow
        name: OpenSSH
      
    - name: allow local range on ufw
      ufw:
        rule: allow
        src: 10.0.0.0/24
      
    - name: enable ufw firewall
      ufw:
        state: enabled

- name: securize sshd conf
  copy:
    src: "{{ role_path }}/files/sshd.conf"
    dest: /etc/ssh/sshd_config.d/secure_sshd.conf
    mode: 0600
    validate: /usr/sbin/sshd -T -f %s
  notify:
   - reload sshd

- name: configure fail2ban
  block:
    - name: install fail2ban package
      apt:
        name: fail2ban
        update_cache: yes

    - name: copy fail2ban conf
      copy:
        src: "{{ role_path }}/files/fail2ban.conf"
        dest: /etc/fail2ban/jail.local
        mode: 0600
      notify:
        - reload fail2ban

    - name: enable fail2ban
      service:
        name: fail2ban
        state: started

- name: configure automatic update
  block:
    - name: Ensure unused dependencies are removed
      lineinfile:
        path: /etc/apt/apt.conf.d/50unattended-upgrades
        regexp: '^//Unattended-Upgrade::Remove-Unused-Dependencies'
        line: 'Unattended-Upgrade::Remove-Unused-Dependencies "true";'

    - name: Ensure unused kernel packages are removed
      lineinfile:
        path: /etc/apt/apt.conf.d/50unattended-upgrades
        regexp: '^//Unattended-Upgrade::Remove-Unused-Kernel-Packages'
        line: 'Unattended-Upgrade::Remove-Unused-Kernel-Packages "true";'

    - name: copy automatic unattended upgrades conf
      copy:
        src: "{{ role_path }}/files/automatic-upgrades.conf"
        dest: /etc/apt/apt.conf.d/20auto-upgrades
        mode: 0600
